FlaskReminder_Options = {
	show = true,
	lock = false,
	setflask = nil,
	alpha = 1,
	popup = true,
	anchor = false,
	flasksleft = 2,
	enabled = true,
	timeleft = 300
};

FlaskReminder_UpdateInterval = 3.0;

 --------------------- ONLOAD FUNCTIONS ---------------------

function FlaskReminder_OnLoad(self)
	SLASH_FLASKREMINDER1 = "/flaskreminder";
	SLASH_FLASKREMINDER2 = "/fr";
    SlashCmdList["FLASKREMINDER"] = FlaskReminder_SlashCommand;
	FlaskReminder_Frame_Text:SetText(FLASKREMINDER_STANDBY);
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("RAID_ROSTER_UPDATE");
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("RAID_INSTANCE_WELCOME");
	self:RegisterEvent("UNIT_AURA");
	self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("READY_CHECK");
	self.TimeSinceLastUpdate = 0
end
	
function FlaskReminder_OnEvent(self, event, ...)
    if ( event == "VARIABLES_LOADED" ) then
        FlaskReminder_Init_Display();
		FlaskReminder_Frame:SetAlpha(FlaskReminder_Options.alpha);
		FlaskReminder_Options.anchor = false;
    end
end
	
	--------------------- SLASH COMMANDS/TOGGLES ---------------------
	
function FlaskReminder_SlashCommand(msg)
	msg = string.lower(msg);
	local args = {};
	for word in string.gmatch(msg, "[^%s]+") do
		table.insert(args, word);
	end
	if ( args[1] ) then
		if ( args[1] == "options" ) then
			FlaskReminder_Options_Toggle();
		elseif ( args[1] == "lock" ) then
			FlaskReminder_Options.lock = not FlaskReminder_Options.lock;
		elseif ( args[1] == "enable" ) then
			FlaskReminder_Enable();
		elseif ( args[1] == "toggle" ) then
			if ( FlaskReminder_Options.enabled == true ) then
				FlaskReminder_Toggle();
			elseif ( FlaskReminder_Options.enabled == false ) then
				FlaskReminder_Message(FLASKREMINDER_OPTIONS_DISABLED);
			end
		elseif ( args[1] == "popup" ) then
			if ( FlaskReminder_Options.enabled == true ) then
				FlaskReminder_Options.popup = not FlaskReminder_Options.popup;
			elseif ( FlaskReminder_Options.enabled == false ) then
				FlaskReminder_Message(FLASKREMINDER_OPTIONS_DISABLED);
			end
		elseif ( args[1] == "anchor" ) then
			FlaskReminder_Anchor_Toggle();
		elseif ( args[1] == "time" ) then
			local timeleft = tonumber(args[2])
			if ( timeleft == 1 ) then
				FlaskReminder_Options.timeleft = 60
				FlaskReminder_Message(FLASKREMINDER_TIME1);
			elseif ( timeleft == 2 ) then
				FlaskReminder_Options.timeleft = 120
				FlaskReminder_Message(FLASKREMINDER_TIME2);
			elseif ( timeleft == 5 ) then
				FlaskReminder_Options.timeleft = 300
				FlaskReminder_Message(FLASKREMINDER_TIME5);
			elseif ( timeleft == 10 ) then
				FlaskReminder_Options.timeleft = 600
				FlaskReminder_Message(FLASKREMINDER_TIME10);
			else
				FlaskReminder_Message(FLASKREMINDER_TIME_WRONG);
			end
		elseif ( args[1] == "alpha" ) then
			local alpha = tonumber(args[2])
			if ( alpha and alpha >= 0 and alpha <= 1 ) then
				FlaskReminder_Options.alpha = alpha;
				FlaskReminder_Frame:SetAlpha(alpha);
			else
				FlaskReminder_Message(FLASKREMINDER_ALPHAWRONG);
			end
		else
			FlaskReminder_Message(FLASKREMINDER_NOCOMMAND);
		end
		if ( FlaskReminder_Options_Frame:IsShown() ) then
			FlaskReminder_Options_Init();
		end
	else
		FlaskReminder_Message(FLASKREMINDER_USAGE);
		FlaskReminder_Message("enable - "..FLASKREMINDER_OPTIONS_ENABLE);
		FlaskReminder_Message("options - "..FLASKREMINDER_OPTIONS);
		FlaskReminder_Message("lock - "..FLASKREMINDER_OPTIONS_LOCK);
		FlaskReminder_Message("toggle - "..FLASKREMINDER_OPTIONS_TOGGLE);
		FlaskReminder_Message("alpha <#> - "..FLASKREMINDER_OPTIONS_ALPHA);
		FlaskReminder_Message("popup - "..FLASKREMINDER_OPTIONS_POPUP);
		FlaskReminder_Message("anchor - "..FLASKREMINDER_OPTIONS_ANCHORTOGGLE);
		FlaskReminder_Message("time <1, 2, 5, 10> - "..FLASKREMINDER_OPTIONS_TIMELEFT);
	end
end

function FlaskReminder_Message(msg)
	DEFAULT_CHAT_FRAME:AddMessage("[FlaskReminder]: "..msg);
end

function FlaskReminder_Enable()
	FlaskReminder_Options.enabled = not FlaskReminder_Options.enabled;
	if ( FlaskReminder_Options.enabled == true ) then
		FlaskReminder_Message(FLASKREMINDER_OPTIONS_ENABLED);
		FlaskReminder_Options.popup = true;
		FlaskReminder_Options_Frame_PopupBox:SetChecked(true);
	elseif ( FlaskReminder_Options.enabled == false ) then
		FlaskReminder_Message(FLASKREMINDER_OPTIONS_DISABLED);
		FlaskReminder_Frame:Hide();
		FlaskReminder_Options_Frame_ShowBox:SetChecked(false);
		FlaskReminder_Options_Frame_PopupBox:SetChecked(false);
		FlaskReminder_Options.popup = false;
	end
end

function FlaskReminder_Toggle()
    if ( FlaskReminder_Frame:IsShown() ) then
        FlaskReminder_Frame:Hide();
		FlaskReminder_Options.show = false
		FlaskReminder_Message(FLASKREMINDER_HIDDEN);
    elseif ( FlaskReminder_Options.enabled == true ) then
        FlaskReminder_Frame:Show();
		FlaskReminder_Options.show = true
		FlaskReminder_Message(FLASKREMINDER_VISIBLE);
	else
		FlaskReminder_Options_Frame_ShowBox:SetChecked(false);
    end
end

function FlaskReminder_Options_Toggle()
	if ( FlaskReminder_Options_Frame:IsShown() ) then
		FlaskReminder_Options_Frame:Hide();
	else
		FlaskReminder_Options_Frame:Show();
	end
end

function FlaskReminder_Anchor_Toggle()
	if ( FlaskReminder_Anchor:IsShown() ) then
		FlaskReminder_Anchor:Hide();
		FlaskReminder_Options.anchor = false
	else
		FlaskReminder_Anchor:Show();
		FlaskReminder_Options.anchor = true
	end
end

function FlaskReminder_Init_Display()
    if ( not FlaskReminder_Options.show ) then
        FlaskReminder_Frame:Hide();
	elseif ( FlaskReminder_Options.enabled == true ) then
		FlaskReminder_Frame:Show();
   end
end

	---------------------  TimeLeft ---------------------
	
function FlaskReminder_TimeLeft(self, elapsed)
	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed; 	
	if (self.TimeSinceLastUpdate > FlaskReminder_UpdateInterval) then
		if ( FlaskReminder_Options.enabled == true and FR_Active == false and FlaskReminder_Options.setflask ~= nil ) then
			local inInstance, instanceType = IsInInstance();
			if ( instanceType == "raid" ) then
				local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitBuff("player", FlaskReminder_Options.setflask)
				if ( name == FlaskReminder_Options.setflask ) then
					local FR_time = GetTime()
					FR_Expiration = expirationTime - FR_time
					if ( FR_Expiration < FlaskReminder_Options.timeleft ) then
						FR_Active2 = true;
						FlaskReminder_Frame:Show();
						FlaskReminder_Frame_Text:SetText(FLASKREMINDER_NEW);
						FlaskReminder_Frame_Red:Show();
						FlaskReminder_Frame:SetBackdropColor(1, 0, 0, 0.4)
						if ( FlaskReminder_Options.popup == true ) then
							while FR_TL == 1 do
								FR_TL = 2;
								FlaskReminder_Anchor_Popup_Text:SetText(FLASKREMINDER_NEW);
								FlaskReminder_Anchor_Popup_Fade();
							end
						end
					else
						FR_Active2 = false;
						FR_TL = 1;
						FlaskReminder_Standby_Function();
					end
				else
					FR_Active2 = false;
				end
			end
		end
		self.TimeSinceLastUpdate = 0;
	end
end

	---------------------  DRINK YOUR FLASK/UNIT AURA ---------------------

function FlaskReminder_BuffChange(self)
	if ( event == "PLAYER_REGEN_DISABLED" or event == "READY_CHECK" and FR_Active == false and FR_Active2 == false ) then
		if ( FlaskReminder_Options.enabled == true and FlaskReminder_Options.setflask ~= nil ) then
			local inInstance, instanceType = IsInInstance();
			if ( instanceType == "raid" ) then
				local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId = UnitBuff("player", FlaskReminder_Options.setflask);
				if ( name == FlaskReminder_Options.setflask ) then
					FlaskReminder_Standby_Function();
				elseif ( name ~= FlaskReminder_Options.setflask ) then
					FlaskReminder_Frame:Show();
					FlaskReminder_Frame_Text:SetText(FLASKREMINDER_DRINK);
					FlaskReminder_Frame_Red:Show();
					FlaskReminder_Frame:SetBackdropColor(1, 0, 0, 0.4)
					if ( FlaskReminder_Options.popup == true and FR_Active == false  and FR_Active2 == false ) then
						FlaskReminder_Anchor_Popup_Text:SetText(FLASKREMINDER_DRINK);
						FlaskReminder_Anchor_Popup_Fade();
					end
				end
			end
		end
	end
end

	---------------------  FLASKS LEFT  ---------------------
	
function FlaskReminder_FlasksLeft(self)
	if ( event == "BAG_UPDATE" or event == "RAID_ROSTER_UPDATE" or event == "UNIT_AURA" ) then
		if ( FlaskReminder_Options.enabled == true and FlaskReminder_Options.setflask ~= nil ) then
			FR_Raidnum = GetNumRaidMembers();
			if ( FR_Raidnum >= 2 ) then
				local itemCount = GetItemCount(FlaskReminder_Options.setflask);
				if ( itemCount <= FlaskReminder_Options.flasksleft ) then
					FR_Active = true;
					FlaskReminder_Frame:Show();
					FlaskReminder_Frame_Text:SetText(FLASKREMINDER_MORE);
					FlaskReminder_Frame:SetBackdropColor(1, 0, 0, 0.4);
					FlaskReminder_Frame_Red:Show();
					if ( FlaskReminder_Options.popup == true ) then
						while FR_FL == 1 do
							FR_FL = 2;
							FlaskReminder_Anchor_Popup_Text:SetText(FLASKREMINDER_MORE);
							FlaskReminder_Anchor_Popup_Fade();
						end
					end
				else
					FR_FL = 1;
					FR_Active = false;
				end
			else
				FlaskReminder_Standby_Function();
			end
		end
	end
end

	---------------------  BUTTONS DROP DOWN 1  ---------------------
	
function FlaskReminder_Time_DropDownOnLoad(self)
	UIDropDownMenu_Initialize(self, FlaskReminder_Time_InitializeDropDown);
end
	
function FlaskReminder_Time_InitializeDropDown(level)
	local info = {}
	info.text = "1 Minute"
	function info.func()
		FlaskReminder_Options.timeleft = 60;
		FlaskReminder_Message(FLASKREMINDER_TIME1);
	end
	UIDropDownMenu_AddButton(info)
	info = {}
	info.text = "2 Minutes"
	function info.func()
		FlaskReminder_Options.timeleft = 120;
		FlaskReminder_Message(FLASKREMINDER_TIME2);
	end
	UIDropDownMenu_AddButton(info)
	info = {}
	info.text = "5 Minutes"
	function info.func()
		FlaskReminder_Options.timeleft = 300;
		FlaskReminder_Message(FLASKREMINDER_TIME5);
	end
	UIDropDownMenu_AddButton(info)
	info = {}
	info.text = "10 Minutes"
	function info.func()
		FlaskReminder_Options.timeleft = 600;
		FlaskReminder_Message(FLASKREMINDER_TIME10);
	end
	UIDropDownMenu_AddButton(info)
end

function FlaskReminder_Time_ButtonOnClick(self, button, down)
	ToggleDropDownMenu(1, nil, FlaskReminder_DropDown_Time, self:GetName(), 0, 0);
end

	---------------------  BUTTONS DROP DOWN 2  ---------------------
	
function FlaskReminder_Remainder_DropDownOnLoad(self)
	UIDropDownMenu_Initialize(self, FlaskReminder_Remainder_InitializeDropDown);
end
	
function FlaskReminder_Remainder_InitializeDropDown(level)
	local info = {}
	info.text = "Set Flasks Remaining Warning to 0"
	function info.func()
		FlaskReminder_Options.flasksleft = 0;
		FlaskReminder_Message(FLASKREMINDER_FLASK0);
	end
	UIDropDownMenu_AddButton(info)
	info = {}
	info.text = "Set Flasks Remaining Warning to 1"
	function info.func()
		FlaskReminder_Options.flasksleft = 1;
		FlaskReminder_Message(FLASKREMINDER_FLASK1);
	end
	UIDropDownMenu_AddButton(info)
	info = {}
	info.text = "Set Flasks Remaining Warning to 2"
	function info.func()
		FlaskReminder_Options.flasksleft = 2;
		FlaskReminder_Message(FLASKREMINDER_FLASK2);
	end
	UIDropDownMenu_AddButton(info)
	info = {}
	info.text = "Set Flasks Remaining Warning to 3"
	function info.func()
		FlaskReminder_Options.flasksleft = 3;
		FlaskReminder_Message(FLASKREMINDER_FLASK3);
	end
	UIDropDownMenu_AddButton(info)
end

function FlaskReminder_Remainder_ButtonOnClick(self, button, down)
	ToggleDropDownMenu(1, nil, FlaskReminder_DropDown_Remainder, self:GetName(), 0, 0);
end

---------------------  BUTTONS DROP DOWN 3 ---------------------
	
function FlaskReminder_DropDownOnLoad(self)
	UIDropDownMenu_Initialize(self, FlaskReminder_InitializeDropDown);
end
	
function FlaskReminder_InitializeDropDown(level)
	local info = {}
	info.text = "Endless Rage"
	function info.func()
		FlaskReminder_Options.setflask = "Flask of Endless Rage";
		FlaskReminder_Message(FLASKREMINDER_FLASK_ER);
	end
	UIDropDownMenu_AddButton(info)
	info = {}
	info.text = "Frost Wyrm"
	function info.func()
		FlaskReminder_Options.setflask = "Flask of the Frost Wyrm";
		FlaskReminder_Message(FLASKREMINDER_FLASK_FW);
	end
	UIDropDownMenu_AddButton(info)
	info = {}
	info.text = "Stoneblood"
	function info.func()
		FlaskReminder_Options.setflask = "Flask of Stoneblood";
		FlaskReminder_Message(FLASKREMINDER_FLASK_SB);
	end
	UIDropDownMenu_AddButton(info)
	info = {}
	info.text = "Pure Mojo"
	function info.func()
		FlaskReminder_Options.setflask = "Flask of Pure Mojo";
		FlaskReminder_Message(FLASKREMINDER_FLASK_PM);
	end
	UIDropDownMenu_AddButton(info)
end

function FlaskReminder_ButtonOnClick(self, button, down)
	ToggleDropDownMenu(1, nil, FlaskReminder_DropDown, self:GetName(), 0, 0);
end

function FlaskReminder_OnEnter(self)
	GameTooltip_SetDefaultAnchor(GameTooltip, self);
	GameTooltip:SetText("FlaskReminder");
	if ( FlaskReminder_Options.lock ) then
		GameTooltip:AddLine(FLASKREMINDER_LOCKED);
	else
		GameTooltip:AddLine(FLASKREMINDER_LEFTCLICK);
	end
	GameTooltip:AddLine(FLASKREMINDER_RIGHTCLICK);
	GameTooltipTextLeft1:SetTextColor(1, 1, 1);
	GameTooltipTextLeft2:SetTextColor(1, 1, 1);
	GameTooltip:Show();
end
	
function FlaskReminder_SetupSlider(self, text, myMin, myMax, step)
	getglobal(self:GetName().."Text"):SetText(text);
	getglobal(self:GetName().."Low"):SetText(myMin);
	getglobal(self:GetName().."High"):SetText(myMax);
	self:SetMinMaxValues(myMin, myMax);
	self:SetValueStep(step);
end

	---------------------  OTHER FUNTIONS  ---------------------
	
function FlaskReminder_Anchor_Popup_Fade()
	UIFrameFadeIn(FlaskReminder_Anchor_Popup, 5, 0, 1);
	UIFrameFadeOut(FlaskReminder_Anchor_Popup, 10, 1, 0);
end

function FlaskReminder_Popup_Test()
	if ( FlaskReminder_Options.enabled == true ) then
		if ( FlaskReminder_Options.popup == true ) then
			FlaskReminder_Anchor_Popup_Text:SetText(FLASKREMINDER_OPTIONS_TESTING);
			FlaskReminder_Anchor_Popup_Fade();
		end
	end
end

function FlaskReminder_Standby_Function()
	FlaskReminder_Frame_Text:SetText(FLASKREMINDER_STANDBY);
	FlaskReminder_Frame_Red:Hide();
	FlaskReminder_Frame:SetBackdropColor(0, 0, 0, 0.4);
end	